'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Cloud;

var _WireFormat = require('./WireFormat');

function Cloud(app, name) {
  var data = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  if (typeof name !== 'string' || name.length === 0) {
    throw new TypeError('Cloud function name must be a string.');
  }

  var payload = (0, _WireFormat.encode)(data);

  return app.client.post('functions/' + name, payload, {}).then(function (res) {
    var decoded = (0, _WireFormat.decode)(res);
    if (decoded && decoded.hasOwnProperty('result')) {
      return Promise.resolve(decoded.result);
    }
    return Promise.reject('The server returned an invalid response.');
  });
}